<?php
require("../LdapManager.php");
require("../LdapObjClassDef.php");
require("../LdapConf.php");

function printObjInfo($res,$objRaw,$name) {
    $res.='<objectClass name="'.$name.'"';
    if (strpos($objRaw," AUXILIARY ")===false) {
        $res.=' structural="true"';
    }
    else {
        $res.=' structural="false"';
    }
    $res.='/>'."\n";
    return $res;
}

$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
$lm->connectLdap($LDAP_USER,$LDAP_PASS);

header('Content-type: text/xml');
$res="<SchemaData>\n";
if (array_key_exists('get',$_GET)) {
    $requestedData=$_GET['get'];
    // Get objectClass definition
    if (strcmp($requestedData,"objectClassDefinition")==0) {
        $filter=array();
        if (array_key_exists('filter',$_GET)) {
            $filter=explode(",",$_GET['filter']);
        }
        $fullinfo=true;
        if (array_key_exists('fullinfo',$_GET)) {
            if (strcmp($_GET['fullinfo'],"true")==0)
                $fullinfo=true;
            else
                $fullinfo=false;
        }
        $entry=$lm->getEntry("cn=SubSchema",array("objectClasses"));
        $attrs=$entry->getAttributes();
        $listObj=$attrs["objectClasses"];
        foreach ($listObj as $objRaw) {
            $objInfo=new LdapObjClassDef($objRaw);
            if (count($filter)==0||(count($filter)>0&&in_array($objInfo->getName(),$filter))) {
                $res.=$objInfo->getXML($fullinfo)."\n";
            }
        }
    }
    else if (strcmp($requestedData,"availableAttributes")==0) {
        $availableMustAttributes=array();
        $availableMayAttributes=array();
        if (array_key_exists('filter',$_GET)) {
            $filter=explode(",",$_GET['filter']);
            $entry=$lm->getEntry("cn=SubSchema",array("objectClasses"));
            $attrs=$entry->getAttributes();
            $listObj=$attrs["objectClasses"];
            foreach ($listObj as $objRaw) {
                $objInfo=new LdapObjClassDef($objRaw);
                if (in_array($objInfo->getName(),$filter)) {
                    $must=$objInfo->getMustAttributes();
                    foreach ($must as $attr) {
                        if (!in_array($attr,$availableMustAttributes)) {
							if (in_array($attr,$availableMayAttributes)) {
								unset($availableMayAttributes[$attr]);
							}
                            array_push($availableMustAttributes,$attr);
                        }
                    }
                    $may=$objInfo->getMayAttributes();
                    foreach ($may as $attr) {
                        if (!in_array($attr,$availableMustAttributes)&&!in_array($attr,$availableMayAttributes)) {
                            array_push($availableMayAttributes,$attr);
                        }
                    }
                }
            }
        }
        $availableAttributes=array_merge($availableMustAttributes,$availableMayAttributes);
        sort($availableAttributes);
        foreach ($availableAttributes as $nameAttr) {
            $res.='<Attribute name="'.$nameAttr.'" mandatory="'.(in_array($nameAttr,$availableMustAttributes)?"true":"false").'"/>'."\n";
        }
    }
}
$res.="</SchemaData>\n";

echo $res;
?>
